------------------------------------------------------------------
-- drop objects if they exist
------------------------------------------------------------------
drop table log_error_example_table;
drop table log_error_example_error;

------------------------------------------------------------------
-- Create table to perform DML on
------------------------------------------------------------------
create table log_error_example_table
(id       number(15,0)   not null
,value    number
);

------------------------------------------------------------------
-- Create a constraint that will cause errors
------------------------------------------------------------------
alter table log_error_example_table
add (constraint log_error_example_table_ck1
     check (-- Value must be more than 0
            value > 0
           )
    );


------------------------------------------------------------------
-- Create a log table 
------------------------------------------------------------------
begin
  dbms_errlog.create_error_log(dml_table_name       => 'log_error_example_table'
                              ,err_log_table_name   => 'log_error_example_error'
                              );
end;
/

------------------------------------------------------------------
-- Insert 10 Rows, every third one will fail
------------------------------------------------------------------
insert
into   log_error_example_table
       (id
       ,value
       )
select level * 111            id
,      100 * mod(level , 3)   value
from   dual
connect by level <= 10
log errors 
into log_error_example_error 
('my first test of log_errors') 
reject limit unlimited
;


commit;


------------------------------------------------------------------
-- Query the table and the log table
------------------------------------------------------------------
select * from log_error_example_table;
select * from log_error_example_error;
