------------------------------------------------------------------
-- Fetch records from a table in bulk
------------------------------------------------------------------
set timing on

declare
  cn_bulk_limit  constant  integer  := 1000;

  cursor c_err
  is
  select rec_id
  ,      cust_last_name
  from   bulk_errors_perf
  ;

  type ta_err is table of c_err%rowtype  index by pls_integer;
  a_err     ta_err;
  
  l_count   integer  := 0;
begin
  open  c_err;
  loop
    fetch c_err
    bulk collect
    into  a_err
    limit cn_bulk_limit;

    exit when a_err.count = 0;

    for i_err in 1 .. a_err.count
    loop
      l_count := l_count + 1;
    end loop;
  end loop;
  close c_err;
 
  dbms_output.put_line ('Records fetched: '||to_char(l_count,'fm999g999g999','NLS_NUMERIC_CHARACTERS = '',.'''));
end;
/

set timing off
