------------------------------------------------------------------
-- Fetch records from a table slow-by-slow
------------------------------------------------------------------
set timing on

declare
  cn_bulk_limit  constant  integer  := 1000;

  cursor c_err
  is
  select rec_id
  ,      cust_last_name
  from   bulk_errors_perf
  ;

  r_err    c_err%rowtype;
  
  l_count   integer  := 0;
begin
  open  c_err;
  loop
    fetch c_err
    into  r_err;

    exit when c_err%notfound;

    l_count := l_count + 1;
  end loop;
  close c_err;
 
  dbms_output.put_line ('Records fetched: '||to_char(l_count,'fm999g999g999','NLS_NUMERIC_CHARACTERS = '',.'''));
end;
/

set timing off
